//  load.c   load input object file

#include "z0.h"

int ninst;
FILE *fp;
int ip;

extern int R[], IR, AC, PC, F, M[];
extern int runflag, savePc;

PRIVATE char ob[256];	// output buffer

void error(char *s){
	printf("error: %s at %d\n",s,PC);
	exit(0);
}

// IR bits
int IRop(void)  { return (IR >> 24) & 0x0ff;} 	// bit 31..24
int IRarg(void) { return IR & 0x0ffffff;} 		// bit 23..0

extern char *cp2;

// -----load object code from file -----

// get one charactor skip newline and blank
/*
PRIVATE char geta(void){
  char s[32];
  fscanf(fp,"%s",s);
  return s[0] ;
}
*/
PRIVATE int geti(void){	// get one integer
	int c;
	fscanf(fp,"%d",&c);
	return c;
}

// set maximum of number to be read to 2000
//   to prevent infinite loop when input is incorrect
void loadprogram(char *name){
	int cnt, op, arg, ads, n;

	fp = fopen(name,"r");
	if(fp == NULL){
		printf("input file not found");
		exit(0);
	}
	ip = 0;
	cnt = 0;
	while( cnt < 2000 ){
		op = geti();
		if( op == 0 ){
			cnt = 2000; 		// end of input
		}else{
			arg = geti();
			M[ip] = (op << 24) | arg;
		}
		ip++;
		cnt++;
	}
	ads = geti();
	if( ads > 0 ){				// data segment ads
		n = geti();				// len
		while( n > 0 ){
			M[ads] = geti();
			ads++;
			n--;
		}
	}
	fclose(fp);
	printf("load program, last address %d\n",ip);
}

PRIVATE void disassem(void){
	int op, arg;
	op = IRop();
	arg = IRarg();
	switch( op ) {
	case LD:  sprintf(ob,"ld %d", arg); break;
	case LDD: sprintf(ob,"ldd r%d", arg); break;
	case ST:  sprintf(ob,"st r%d", arg); break;
	case STD: sprintf(ob,"std r%d", arg); break;
	case JMP: sprintf(ob,"jmp %d", arg); break;
	case JT:  sprintf(ob,"jt %d", arg); break;
	case JF:  sprintf(ob,"jf %d", arg); break;
	case MOV: sprintf(ob,"mov r%d", arg); break;
	case MVI: sprintf(ob,"mvi %d", arg); break;
	case PUT: sprintf(ob,"put r%d", arg); break;
	case ADD: sprintf(ob,"add r%d", arg); break;
	case SUB: sprintf(ob,"sub r%d", arg); break;
	case INC: sprintf(ob,"inc r%d", arg); break;
	case DEC: sprintf(ob,"dec r%d", arg); break;
	case EQ:  sprintf(ob,"eq r%d", arg); break;
	case NE:  sprintf(ob,"ne r%d", arg); break;
	case LT:  sprintf(ob,"lt r%d", arg); break;
	case LE:  sprintf(ob,"le r%d", arg); break;
	case GT:  sprintf(ob,"gt r%d", arg); break;
	case GE:  sprintf(ob,"ge r%d", arg); break;
	case Z:   sprintf(ob,"z r%d", arg); break;
	case STOP: sprintf(ob,"stop"); break;
	case CALL: sprintf(ob,"call %d", arg); break;
	case RET:  sprintf(ob,"ret"); break;
	default:  sprintf(ob,"unknown op code");
	}
}

void show(void){		// show some registers
	int i;
	printf("PC%4d ",savePc);
	disassem();
	for(i=strlen(ob); i<18; i++)	// pad blank to 18
		ob[i] = 32;
	ob[i] = 0;
	printf("%s",ob);
	printf("AC:%d ",AC);
	for(i = 0; i < 8; i++)
		printf("r%d:%d ",i,R[i]);
	printf("\n");
}
